


#include <SoftwareSerial.h>

#define RO 4
#define DI 5
//#define RE 6
//#define DE 7

const uint32_t TIMEOUT = 800UL;

const byte get_ID    [] = {0xFE, 0x03, 0x02, 0x00, 0x00, 0x01, 0x91, 0xBD};
const byte moist_cmd [] = {0x01, 0x03, 0x00, 0x00, 0x00, 0x01, 0x84, 0x0A};
const byte temp_cmd  [] = {0x01, 0x03, 0x00, 0x01, 0x00, 0x01, 0xD5, 0xCA};

uint16_t getData (const byte* cmd, byte length);

void printHexByte (byte b);

byte values[7] = {0};
SoftwareSerial mod(RO, DI); // Rx pin, Tx pin

void setup() {



  Serial.begin(9600);

  
  mod.begin(9600);
  //pinMode(RE, OUTPUT);
  //pinMode(DE, OUTPUT);
  delay(500);
}

void loop() {
  float val1, val2, val;
  

  Serial.print("Device ID: ");
  val = getData(get_ID, sizeof(get_ID));
  Serial.print(val);
  Serial.println();
  delay(1000);
  
  Serial.print("Soil moisture: ");
  val1 = getData(moist_cmd, sizeof(moist_cmd) );
  Serial.print(val1/10);
  Serial.println(" %");
  delay(1000);

  Serial.print("Temperature: ");
  val2 = getData(temp_cmd, sizeof(temp_cmd) );
  Serial.print(val2/10);
  Serial.println(" *C");
  delay(1000);


  delay(5000);
}


uint16_t getData( const byte* cmd, byte length) {
  uint32_t startTime = 0;
  uint8_t  byteCount = 0;
  uint16_t val_out = 0;

  //digitalWrite(DE, HIGH);
  //digitalWrite(RE, HIGH);
  delay(10);
  mod.write(cmd, length);
  mod.flush();
  //digitalWrite(DE, LOW);
  //digitalWrite(RE, LOW);

  startTime = millis();
  //Serial.println();
  while ( millis() - startTime <= TIMEOUT ) {
    
    if (mod.available() && byteCount < sizeof(values) ) {
      values[byteCount++] = mod.read();
      //printHexByte(values[byteCount-1]);
    }
  }
  //Serial.println();
  //TODO: you have to cast from values array the selected value to print it out 
  // and return in val_out
  val_out = (uint16_t)((values[3]&0x00ff)<<8 | (values[4]&0xff));
  return val_out;
}


void printHexByte(byte b)
{
  Serial.print((b >> 4) & 0xF, HEX);
  Serial.print(b & 0xF, HEX);
  Serial.print(' ');
}

